import 'package:flutter/material.dart';
import 'package:video_player/video_player.dart';

typedef Widget VideoWidgetBuilder(
    BuildContext context, VideoPlayerController controller);

class Cycle extends StatefulWidget {
  final VideoPlayerController controller;
  final VideoWidgetBuilder childBuilder;
  final bool loop;
  final bool autoPlay;

  Cycle(this.controller, this.childBuilder, this.loop, this.autoPlay, {Key key})
      : super(key: key);

  @override
  CycleState createState() => CycleState();
}

class CycleState extends State<Cycle> {
  VideoPlayerController get controller => widget.controller;

  @override
  void initState() {
    super.initState();
    controller.addListener(() {
      if (controller.value.hasError) {
        print(controller.value.errorDescription);
      }
    });
    controller.initialize();
    controller.setLooping(widget.loop);
    if(widget.autoPlay){
      controller.play();
    }
  }

  @override
  void deactivate() {
    super.deactivate();
  }

  @override
  Widget build(BuildContext context) {
    return widget.childBuilder(context, controller);
  }
}